package cn.iocoder.yudao.module.mes.service.moldreturn;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.mes.controller.admin.moldreturn.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.moldreturn.MoldReturnDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.mes.dal.mysql.moldreturn.MoldReturnMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;

/**
 * 模具管理-模具入库 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class MoldReturnServiceImpl implements MoldReturnService {

    @Resource
    private MoldReturnMapper moldReturnMapper;

    @Override
    public Long createMoldReturn(MoldReturnSaveReqVO createReqVO) {
        // 插入
        MoldReturnDO moldReturn = BeanUtils.toBean(createReqVO, MoldReturnDO.class);
        moldReturnMapper.insert(moldReturn);
        // 返回
        return moldReturn.getId();
    }

    @Override
    public void updateMoldReturn(MoldReturnSaveReqVO updateReqVO) {
        // 校验存在
        validateMoldReturnExists(updateReqVO.getId());
        // 更新
        MoldReturnDO updateObj = BeanUtils.toBean(updateReqVO, MoldReturnDO.class);
        moldReturnMapper.updateById(updateObj);
    }

    @Override
    public void deleteMoldReturn(Long id) {
        // 校验存在
        validateMoldReturnExists(id);
        // 删除
        moldReturnMapper.deleteById(id);
    }

    private void validateMoldReturnExists(Long id) {
        if (moldReturnMapper.selectById(id) == null) {
            throw exception(MOLD_RETURN_NOT_EXISTS);
        }
    }

    @Override
    public MoldReturnDO getMoldReturn(Long id) {
        return moldReturnMapper.selectById(id);
    }

    @Override
    public PageResult<MoldReturnDO> getMoldReturnPage(MoldReturnPageReqVO pageReqVO) {
        return moldReturnMapper.selectPage(pageReqVO);
    }

}